//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#include <ap.h>

#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPort"
#pragma resource "*.dfm"
TTestForm       *TestForm;
unsigned long   dwThreadID;
bool            readyExitD=1;
bool            readyExitR=1;
DWORD             br;
unsigned char   count_cicle=0;  //   .  5 
                                //  
int             count_error=0;  //   
HANDLE          hThrRead;
//HANDLE          hThrDraw;
HANDLE          hCOM;


//    
unsigned char   BI;

//      - bottomAxis->maximum
double  BA1[] = {100,   200,    500,    1,      2.5,    5,      12.5,   25,     62.5};

//      - bottomAxis->maximum
double  BA2[] = {2500,  1250,   500,    250,    100,    50,     20,     10,     4};



struct  PARAM
        {
        unsigned char           recieved[1024];         // e   
        char                    *transmit;              //  
        double                  buf_in[32768];          //   /     
        ap::real_1d_array       buf_in_r;
        bool                    open;
        bool                    draw;
        bool                    read;
        double                  max_rx;                 //     
//        double                  max_fft;                // max    
        };
static struct   PARAM  paramThr;
//---------------------------------------------------------------------------
void            ThrRead(void *lpvoid);
void            DrawS(unsigned char *temp_str, double *temp_str2);
void            DrawFFT(ap::real_1d_array &temp_array,double *temp_str2);
double          max(const double *array);
HANDLE          InitCOM(DCB *dcb, COMMTIMEOUTS &ct);

void realfastfouriertransform(ap::real_1d_array& a, int tnn, bool inversefft);

double CPUSpeed(void) 
{ 
    DWORD dwTimerHi, dwTimerLo; 
    asm
     { 
        DW 0x310F 
        mov dwTimerLo, EAX 
        mov dwTimerHi, EDX 
      } 
    Sleep (500); 
    asm
     { 
        DW 0x310F 
        sub EAX, dwTimerLo 
        sub EDX, dwTimerHi 
        mov dwTimerLo, EAX 
        mov dwTimerHi, EDX 
     } 
    return dwTimerLo/(1000.0*500); 
}

//---------------------------------------------------------------------------
__fastcall TTestForm::TTestForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TTestForm::btnConnectClick(TObject *Sender)
{
        unsigned long   lErrorCode;
        if (!paramThr.open)
        {
                paramThr.draw=false;
                paramThr.read=true;

                hThrRead=CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ThrRead, &paramThr, 0, &dwThreadID);
    //            hThrDraw=CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ThrDraw, &paramThr, 0, &dwThreadID);
                paramThr.open=true;
        }
        else paramThr.open=false;
}
//---------------------------------------------------------------------------
void __fastcall TTestForm::FormCreate(TObject *Sender)
{
        Caption=Caption+"  : "+FloatToStr(CPUSpeed());
        paramThr.open=false;
        paramThr.read=true;
        paramThr.draw=false;
        mmInfo->Lines->Add(" ");
//        SetPriorityClass(Application->Handle, HIGH_PRIORITY_CLASS);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void ThrRead (void *lpvoid)
{
  readyExitR=false;
  struct PARAM *paramThr=(struct PARAM *)lpvoid;

  DCB             *dcb;
  COMMTIMEOUTS    ct;

   //       :
  dcb=(DCB*)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sizeof(DCB));


  paramThr->transmit = "ppppppp";
  // char g=0x52;
  char query[8] = {'q', 'r', 'r', 'r', 'r', 'r', 'r', 'r'};

  //  
  hCOM=InitCOM(dcb, ct);

  //   :
  if (hCOM == INVALID_HANDLE_VALUE) {
       Application->MessageBoxA("     !", "  !", MB_OK);
       TestForm->btnConnect->Caption="";
       paramThr->open=false;
      ExitThread(0);
      }

   //   :
   //     :
  else if (!(SetCommState(hCOM,dcb))) {
     Application->MessageBoxA("    !", "  !", MB_OK);
     PurgeComm(hCOM,PURGE_RXCLEAR);
     CloseHandle(hCOM);
     HeapFree(GetProcessHeap(),0,dcb);
     TestForm->btnConnect->Caption="";
     paramThr->open=false;
     ExitThread(0);
     }

   //    :
   //     :
  else if (!(SetCommTimeouts(hCOM,&ct))) {
     Application->MessageBoxA("    !", "  !", MB_OK);
     PurgeComm(hCOM,PURGE_RXCLEAR);
     CloseHandle(hCOM);
     HeapFree(GetProcessHeap(),0,dcb);
     TestForm->btnConnect->Caption="";
     paramThr->open=false;
     ExitThread(0);
     }

   //    :
   //         
  else if (!(SetupComm(hCOM, 1024, 256))) {
     Application->MessageBoxA("       !", "  !", MB_OK);
     PurgeComm(hCOM, PURGE_TXCLEAR|PURGE_RXCLEAR);
     CloseHandle(hCOM);
     HeapFree(GetProcessHeap(),0,dcb);
     TestForm->btnConnect->Caption="";
     paramThr->open=false;
     ExitThread(0);
     }

   //   :
        paramThr->open=true;
        HeapFree(GetProcessHeap(),0,dcb);
        TestForm->btnConnect->Caption="";
        TestForm->mmInfo->Lines->Add(" !");
        PurgeComm(hCOM,PURGE_RXCLEAR);

        while (paramThr->open)
        {
            if(paramThr->read)
            {


                int k;
                PurgeComm(hCOM, PURGE_TXCLEAR|PURGE_RXCLEAR);
                //  
                query[0] = 'q';
                query[1] = TestForm->cbRazv->ItemIndex+1;
                k=WriteFile(hCOM, query /*paramThr->transmit*/, 8 /*strlen(query)*/, &br, NULL);

                //  
                k=ReadFile(hCOM, paramThr->recieved, 1024, &br, NULL);

                if (!k)
                {
                        TestForm->mmInfo->Lines->Add(IntToStr(count_error++)+"  !");
                }

                if (paramThr->recieved[0]=='e' && paramThr->recieved[1]=='r')
                {
                        TestForm->mmInfo->Lines->Add(IntToStr(count_error++)+"   !");
                        br=0;
                }



                if (br==1024)
                {
                        if (    paramThr->recieved[0]!='a'|
                        paramThr->recieved[1]!='n'|
                        paramThr->recieved[2]!='s'|
                        paramThr->recieved[3]!='w'|
                        paramThr->recieved[4]!='e'|
                        paramThr->recieved[5]!='r'|
                        paramThr->recieved[6]!=query[0]|
                        paramThr->recieved[7]!=query[1]|
                        paramThr->recieved[8]!=query[2]|
                        paramThr->recieved[9]!=query[3]|
                        paramThr->recieved[10]!=query[4]|
                        paramThr->recieved[11]!=query[5]|
                        paramThr->recieved[12]!=query[6]|
                        paramThr->recieved[13]!=query[7])
                        {
                                if (count_error)
                                        TestForm->mmInfo->Lines->Add
                                        (IntToStr(count_error++) + "     !");
                        }
                        else
                        {

                                SetThreadPriority(hThrRead, THREAD_PRIORITY_TIME_CRITICAL/*THREAD_PRIORITY_HIGHEST*/);

                                DrawS(paramThr->recieved, paramThr->buf_in);
                                if(TestForm->cbFFTEnabled->Checked)
                                        DrawFFT(paramThr->buf_in_r, paramThr->buf_in);

                                SetThreadPriority(hThrRead, THREAD_PRIORITY_NORMAL);

                        }
                }

                else
                {
                        if (br==0)
                        {
                                TestForm->mmInfo->Lines->Add("  " + IntToStr(++count_cicle) + "  !");
                                if (count_cicle==10)
                                {
                                        TestForm->btnConnectClick(TestForm);
                                        TestForm->mmInfo->Lines->Add("  !   !");
                                        count_cicle=0;
                                        count_error=0;
                                }
                        }
                        else TestForm->mmInfo->Lines->Add(IntToStr(count_error++)+"    !");
                }

                Application->ProcessMessages();

             }  //    if(paramThr->read)

        }       //    while



        CloseHandle(hCOM);
        TestForm->btnConnect->Caption="";
        TestForm->mmInfo->Lines->Add(" !");
        readyExitR=true;
        ExitThread(0);
}
//---------------------------------------------------------------------------



void __fastcall TTestForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
        paramThr.open=false;
//        while(!(readyExitD  readyExitR)){};
TerminateThread(hThrRead,0);
//TerminateThread(hThrDraw,0);
}
//---------------------------------------------------------------------------






void __fastcall TTestForm::FormClose(TObject *Sender, TCloseAction &Action)
{
        if (paramThr.open) TestForm->btnConnectClick(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TTestForm::btnExitClick(TObject *Sender)
{
        paramThr.open=false;
        Close();
}
//---------------------------------------------------------------------------
void            DrawS(unsigned char *temp_str,double *temp_str2)
{
        TestForm->Series1->Clear();
        double max_rx=(temp_str[112]-128)*0.6/150;


        unsigned char n=0;


        switch (TestForm->cbTrigger->ItemIndex)
        {
                case 1: for (int i=112; i<252; i++)
                        {
                                if (((temp_str[i]-128) <= (TestForm->tbLevel->Position))
                                        && ((temp_str[i+1]-128) > TestForm->tbLevel->Position))
                                        {
                                        n=i-112;
                                        break;
                                        };
                        }
                        break;
                case 2: for (int i=112; i<252; i++)
                        {
                                if (((temp_str[i]-128) >= (TestForm->tbLevel->Position))
                                        && ((temp_str[i+1]-128) < TestForm->tbLevel->Position))
                                        {
                                        n=i-112;
                                        break;
                                        };
                        }
                        break;
                default:
                        ;
        }

        for (int i=112; i<912; i++)
        {
                temp_str2[i-112]=(temp_str[i]-128)*0.6/128;
                if (max_rx < temp_str2[i-112]) max_rx=temp_str2[i-112];
        }


        TestForm->Series3->Clear();
        TestForm->Series3->AddXY(0, TestForm->tbLevel->Position*0.6/128);


        for (int i=0; i<800+n; i++)
        {
                TestForm->Series1->AddXY(((i-n-TestForm->tbPhase->Position)*BA1[BI]/500), temp_str2[i]);
        }

        paramThr.max_rx = max_rx;

}
//---------------------------------------------------------------------------
void DrawFFT(ap::real_1d_array &temp_array, double *temp_str2)
{
        temp_array.setcontent(0, 32767, temp_str2);
        realfastfouriertransform
                (temp_array, 32768, false);
        memcpy(temp_str2, temp_array.getcontent(), 262144/*sizeof(temp_str2)*/);

        TestForm->Chart2->Update();
        TestForm->Series2->Clear();

        TestForm->Series2->AddXY(0, temp_str2[0]);
        temp_str2[0]=0;


        for (int i=1; i<16384; i++)
        {
                double a=temp_str2[2*i];
                double b=temp_str2[2*i+1];
                TestForm->Series2->AddXY(i*2457.6*BA2[BI]/(16384*2500),
                                                sqrt((a*a+b*b)*0.000081) );
                temp_str2[2*i]=0;
                temp_str2[2*i+1]=0;


               // Application->ProcessMessages();
        }
}
//---------------------------------------------------------------------------

/***********************************************************************
    AlgoPascal    ALGLIB

,     ,     
http://alglib.sources.ru/copyrules.php

  

     
,  n    .

     ,  
 ,    .

 :
    tnn  -     .     
            .        
             .
    a   -   array [0 .. nn-1] of Real
             .
    InverseFFT
        -    .
            True,  , False,  .
            
 :
    a   -      .       .
              .
*************************************************************************/
void realfastfouriertransform(ap::real_1d_array& a, int tnn, bool inversefft)
{
    double twr;
    double twi;
    double twpr;
    double twpi;
    double twtemp;
    double ttheta;
    int i;
    int i1;
    int i2;
    int i3;
    int i4;
    double c1;
    double c2;
    double h1r;
    double h1i;
    double h2r;
    double h2i;
    double wrs;
    double wis;
    int nn;
    int ii;
    int jj;
    int n;
    int mmax;
    int m;
    int j;
    int istep;
    int isign;
    double wtemp;
    double wr;
    double wpr;
    double wpi;
    double wi;
    double theta;
    double tempr;
    double tempi;

    if( tnn==1 )
    {
        return;
    }
    if( !inversefft )
    {
        ttheta = double(2*ap::pi())/double(tnn);
        c1 = 0.5;
        c2 = -0.5;
    }
    else
    {
        ttheta = double(2*ap::pi())/double(tnn);
        c1 = 0.5;
        c2 = 0.5;
        ttheta = -ttheta;
        twpr = -2.0*ap::sqr(sin(0.5*ttheta));
        twpi = sin(ttheta);
        twr = 1.0+twpr;
        twi = twpi;
        for(i = 2; i <= tnn/4+1; i++)
        {
            i1 = i+i-2;
            i2 = i1+1;
            i3 = tnn+1-i2;
            i4 = i3+1;
            wrs = twr;
            wis = twi;
            h1r = c1*(a(i1)+a(i3));
            h1i = c1*(a(i2)-a(i4));
            h2r = -c2*(a(i2)+a(i4));
            h2i = c2*(a(i1)-a(i3));
            a(i1) = h1r+wrs*h2r-wis*h2i;
            a(i2) = h1i+wrs*h2i+wis*h2r;
            a(i3) = h1r-wrs*h2r+wis*h2i;
            a(i4) = -h1i+wrs*h2i+wis*h2r;
            twtemp = twr;
            twr = twr*twpr-twi*twpi+twr;
            twi = twi*twpr+twtemp*twpi+twi;
        }
        h1r = a(0);
        a(0) = c1*(h1r+a(1));
        a(1) = c1*(h1r-a(1));
    }
    if( inversefft )
    {
        isign = -1;
    }
    else
    {
        isign = 1;
    }
    n = tnn;
    nn = tnn/2;
    j = 1;
    for(ii = 1; ii <= nn; ii++)
    {
        i = 2*ii-1;
        if( j>i )
        {
            tempr = a(j-1);
            tempi = a(j);
            a(j-1) = a(i-1);
            a(j) = a(i);
            a(i-1) = tempr;
            a(i) = tempi;
        }
        m = n/2;
        while(m>=2&&j>m)
        {
            j = j-m;
            m = m/2;
        }
        j = j+m;
    }
    mmax = 2;
    while(n>mmax)
    {
        istep = 2*mmax;
        theta = double(2*ap::pi())/double(isign*mmax);
        wpr = -2.0*ap::sqr(sin(0.5*theta));
        wpi = sin(theta);
        wr = 1.0;
        wi = 0.0;
        for(ii = 1; ii <= mmax/2; ii++)
        {
            m = 2*ii-1;
            for(jj = 0; jj <= (n-m)/istep; jj++)
            {
                i = m+jj*istep;
                j = i+mmax;
                tempr = wr*a(j-1)-wi*a(j);
                tempi = wr*a(j)+wi*a(j-1);
                a(j-1) = a(i-1)-tempr;
                a(j) = a(i)-tempi;
                a(i-1) = a(i-1)+tempr;
                a(i) = a(i)+tempi;
            }
            wtemp = wr;
            wr = wr*wpr-wi*wpi+wr;
            wi = wi*wpr+wtemp*wpi+wi;
        }
        mmax = istep;
    }
    if( inversefft )
    {
        for(i = 1; i <= 2*nn; i++)
        {
            a(i-1) = double(a(i-1))/double(nn);
        }
    }
    if( !inversefft )
    {
        twpr = -2.0*ap::sqr(sin(0.5*ttheta));
        twpi = sin(ttheta);
        twr = 1.0+twpr;
        twi = twpi;
        for(i = 2; i <= tnn/4+1; i++)
        {
            i1 = i+i-2;
            i2 = i1+1;
            i3 = tnn+1-i2;
            i4 = i3+1;
            wrs = twr;
            wis = twi;
            h1r = c1*(a(i1)+a(i3));
            h1i = c1*(a(i2)-a(i4));
            h2r = -c2*(a(i2)+a(i4));
            h2i = c2*(a(i1)-a(i3));
            a(i1) = h1r+wrs*h2r-wis*h2i;
            a(i2) = h1i+wrs*h2i+wis*h2r;
            a(i3) = h1r-wrs*h2r+wis*h2i;
            a(i4) = -h1i+wrs*h2i+wis*h2r;
            twtemp = twr;
            twr = twr*twpr-twi*twpi+twr;
            twi = twi*twpr+twtemp*twpi+twi;
        }
        h1r = a(0);
        a(0) = h1r+a(1);
        a(1) = h1r-a(1);
    }
}

//------------------------------------------------------------------------------

double max (const double *array)
{
        double max=array[0];
        for (int i=1; i<sizeof(array)/sizeof(double); i++)
        {
                if (array[i]>max) max=array[i];
        }
        return max;
}

//------------------------------------------------------------------------------
HANDLE InitCOM (DCB *dcb, COMMTIMEOUTS &ct)
{
  HANDLE hCOM;
   //   :
  dcb->DCBlength =      sizeof(DCB);            // 
  dcb->BaudRate =       CBR_115200;             // 
  dcb->fBinary =        TRUE;                   //   
  dcb->fParity =        FALSE;                  //  
  dcb->fOutxCtsFlow =   FALSE;                  //      CTS
  dcb->fOutxDsrFlow =   FALSE;                  //      DSR
  dcb->fDtrControl =    DTR_CONTROL_DISABLE;    //       DTR
  dcb->fDsrSensitivity =FALSE;                  //        DSR
  dcb->fTXContinueOnXoff
                        =TRUE;                  // ,            XoffChar
  dcb->fOutX =          FALSE;                  //   XON/XOFF    
  dcb->fInX =           FALSE;                  //   XON/XOFF    
  dcb->fErrorChar =     FALSE;                  //             ErrorChar
  dcb->fNull =          FALSE;                  //       .    TRUE,      
  dcb->fRtsControl =    RTS_CONTROL_DISABLE;    //       RTS
  dcb->fAbortOnError =  FALSE;                  //     /   
  dcb->fDummy2;                                 //    
//  dcb->wReserved =      0;                      //  ,     0
  dcb->XonLim;                                  //           XON
  dcb->XoffLim;                                 //           XON
  dcb->ByteSize =       8;                      //         
  dcb->Parity =         NOPARITY;               //     
  dcb->StopBits =       ONESTOPBIT;             //    
  dcb->XonChar;                                 //   XON    ,    
  dcb->XoffChar;                                //   XOFF    ,    
  dcb->ErrorChar;                               //  ,       
  dcb->EofChar;                                 //  ,      
  dcb->EvtChar;                                 //  ,     
  dcb->wReserved1;                              //    


  //  :

   //  - 10 :
  ct.ReadIntervalTimeout=50;
   //   -  0
  ct.ReadTotalTimeoutMultiplier=0;
  ct.ReadTotalTimeoutConstant=200;
  ct.WriteTotalTimeoutMultiplier=0;
  ct.WriteTotalTimeoutConstant=200;
  //  ( )
   //     hCOM:
  hCOM=CreateFile((char *)((TestForm->cbCom->Text).data()), GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
  return (hCOM);
}

//------------------------------------------------------------------------------



void __fastcall TTestForm::cbRazvChange(TObject *Sender)
{
        BI = cbRazv->ItemIndex;
        if (cbRazv->ItemIndex>=3) Label3->Caption="";
        if (cbRazv->ItemIndex<3) Label3->Caption="";
        Chart2->BottomAxis->Maximum = BA2[cbRazv->ItemIndex];
        Chart1->BottomAxis->Maximum = BA1[cbRazv->ItemIndex];
}
//---------------------------------------------------------------------------


void __fastcall TTestForm::FormResize(TObject *Sender)
{
  //    - 2  1.
  //        
  //
  int iSH = (TestForm->ClientHeight - StatusBar1->Height - mmInfo->Height);
  int iSW = TestForm->ClientWidth - Panel1->Width;
  Chart1->Height = iSH*2/3;
  Chart2->Height = iSH - Chart1->Height;
  Chart2->Top = Chart1->Height;
  Chart1->Width = iSW;
  Chart2->Width = iSW;
  Label3->Top = Chart1->Height/2;
  Label3->Left = Chart1->Width - 22;
  Label2->Top = Chart2->Height - 15;
  Label2->Left = Chart2->Width - 22;
}
//---------------------------------------------------------------------------

